---------------------------------------------------------------------------------
-- irclog - Prints the content of an IRC Channel to a  File 	             ----
---------------------------------------------------------------------------------

import Network
import System.IO
import Text.Printf
import Data.Maybe

type Options = [(String, String)]

-- This is the Main loop. Her we connect to the server and call the listen routine
main =  withSocketsDo $ do
		putStr "ChoreBot is starting: \n"
        	putStr "Reading Config File ...\n"
		conf <- readFile "./data/config.dat"
		putStr "Setting up a Connection ...\n"
		
		-- Now we read the config.dat file
		let port  = fromJust $ lookup "port" (read conf :: Options)
        	let server = fromJust $ lookup "server" (read conf :: Options)        
		let nick = fromJust $ lookup "nick" (read conf :: Options)
		let chan = fromJust $ lookup "chan" (read conf :: Options)
		let dev = fromJust $ lookup "dev" (read conf :: Options)		
		
		-- Set up connection
		hnd  <- connectTo server (PortNumber (fromIntegral (read (port) ::Int)))        
		hSetBuffering hnd NoBuffering
		write hnd "NICK" nick
    		write hnd "USER" (nick++" 0 * :Irc needle printer")
    		write hnd "JOIN" chan
		listen hnd dev -- We call listen. Arguments are the Handle and a file. 
		putStr "See you Space Cowboy...\n"
	

-- Write does the IRC comunication, writedev returns the strint for the /dev
listen :: Handle -> String -> IO ()
listen h x = do
	t <- hGetLine h
	write h (fst (eval t)) (snd (eval t))
	writedev x (evald t) 
	listen h x 

-- Writes a string to an IRX Channel 
write :: Handle -> String -> String -> IO ()
write h s t = do
    hPrintf h "%s %s\r\n" s t

-- Writes to a File
writedev :: String -> String -> IO ()
writedev a b = do
		-- putStr (b ++ "\n") -- Debug Option: Remove it, and be remove
		appendFile a b

-- Respond to PINGs
eval :: String -> (String, String)
eval ('P':'I':'N':'G':_:xs) = ("PONG",':':(drop 6 xs))
eval x = ("","")

-- Filter everything we want to appear in the log (not much)
evald :: String -> String
evald ('P':'I':'N':'G':_:xs) = ""
evald x = evalc x 

evalc :: String -> String
evalc a | ((getNumber a) == False) = (till (drop 1 a) '!') ++ ": " ++ (drop 1 (dropWhile (/= ':') (drop 1 a))) ++ "\n"
	| otherwise = ""

-- Cut a String
till :: String -> Char -> String
till [] b = []
till (x:xs) b | (x == b) = [x]
              | otherwise = x : till xs b

-- Filter for IRC Status Foo
getNumber :: String -> Bool
getNumber a = isNumber (drop 1 (dropWhile (/= ' ') a))

isNumber :: String -> Bool
isNumber (x:xs) | ((x == '0') || (x == '1') || (x == '2') || (x == '3') || (x == '4') || (x == 'N')) = True
                | otherwise = False
